<template>
  <v-card>
    <v-toolbar
      color="teal"
      :dense="sidebar"
    >
      <v-app-bar-nav-icon>
        <v-icon>label</v-icon>
      </v-app-bar-nav-icon>
      <v-toolbar-title
        v-if="showDetail"
        style="min-width: fit-content;"
      >
        Labels
      </v-toolbar-title>
      <v-spacer />
      <v-btn
        icon
        @click="refreshLabels"
      >
        <v-icon v-if="!updating">
          refresh
        </v-icon>
        <v-progress-circular
          v-else
          indeterminate
          color="black"
          size="20"
        />
      </v-btn>
    </v-toolbar>
    <v-tabs
      v-if="showDetail"
      grow
      color="black"
      background-color="teal lighten-1"
    >
      <v-tab id="list-labels-section">
        List
      </v-tab>
      <v-tab id="create-label-section">
        Create
      </v-tab>
      <v-tab id="update-label-section">
        Update
      </v-tab>
      <v-tab-item>
        <v-container>
          <feedback-label-list />
        </v-container>
      </v-tab-item>
      <v-tab-item>
        <v-container>
          <feedback-label-form />
        </v-container>
      </v-tab-item>
      <v-tab-item>
        <v-container>
          <feedback-label-updater />
        </v-container>
      </v-tab-item>
    </v-tabs>
  </v-card>
</template>

<script lang="ts">
import Vue from 'vue'
import Component from 'vue-class-component'
import { Prop } from 'vue-property-decorator'
import { getLabels } from '@/api'
import { FeedbackLabels } from '@/store/modules/feedback-labels'
import { UI } from '@/store/modules/ui'
import FeedbackLabelList from './FeedbackLabelList.vue'
import FeedbackLabelForm from './FeedbackLabelForm.vue'
import FeedbackLabelUpdater from './FeedbackLabelUpdater.vue'

@Component({
  components: {
    FeedbackLabelList,
    FeedbackLabelForm,
    FeedbackLabelUpdater,
  }
})
export default class FeedbackLabelsList extends Vue {
  @Prop({type: Boolean, default: false}) sidebar!: boolean

  updating = false
  timerId = -1

  get showDetail () {
    return !this.sidebar || (this.sidebar && !UI.state.sideBarCollapsed)
  }

  // fetch labels once, then every 10 seconds
  created () {
    this.refreshLabels()
    this.timerId = setInterval(this.refreshLabels, 10 * 1e3)
  }

  destroyed () {
    clearInterval(this.timerId)
  }

  refreshLabels() {
    this.updating = true
    FeedbackLabels.getLabels().finally(() => {
      this.updating = false
    })
  }
}
</script>

<style>

</style>
